//+------------------------------------------------------------------+
//|                                                       TLBs       |
//+------------------------------------------------------------------+
#property indicator_chart_window
//---- input parameters
extern int nPeriod=5;
extern int nPeriod10=10;
extern int nPeriod15=15;
extern int Limit=350;
extern int Limit10=350;
extern int Limit15=350;
///---- int Widners Oscilator
int cnt,nCurBar=0,nCurBar10=0,nCurBar15=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- Output in Char
   for(cnt=0; cnt<=5; cnt++)
     {
      ObjectCreate("WSO-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WSO-"+cnt,OBJPROP_COLOR,Red);
      if(cnt<5)
        {
         ObjectCreate("Trend DN5-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet("Trend DN5-"+cnt,OBJPROP_COLOR,Yellow);
         ObjectSet("Trend DN5-"+cnt,OBJPROP_STYLE,STYLE_DOT);
        }
      //----
      ObjectCreate("WRO-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WRO-"+cnt,OBJPROP_COLOR,Blue);
      if(cnt<5)
        {
         ObjectCreate("Trend UP5-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet("Trend Up5-"+cnt,OBJPROP_COLOR,Blue);
         ObjectSet("Trend Up5-"+cnt,OBJPROP_STYLE,STYLE_DOT);
        }
     }
//----
//---- Output in Char
   for(cnt=0; cnt<=5; cnt++)
     {
      ObjectCreate("WSO10-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WSO10-"+cnt,OBJPROP_COLOR,FireBrick);
      ObjectSet("WSO10-"+cnt,OBJPROP_WIDTH,2);
      if(cnt<5)
        {
         ObjectCreate("Trend DN10-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet("Trend DN10-"+cnt,OBJPROP_COLOR,Red);
         ObjectSet("Trend DN10-"+cnt,OBJPROP_WIDTH,1);
        }
      //----
      ObjectCreate("WRO10-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WRO10-"+cnt,OBJPROP_COLOR,Blue);
         ObjectSet("WRO10-"+cnt,OBJPROP_WIDTH,1);
      if(cnt<5)
        {
         ObjectCreate("Trend UP10-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet("Trend Up10-"+cnt,OBJPROP_COLOR,Green);
         ObjectSet("Trend Up10-"+cnt,OBJPROP_WIDTH,1);
        }
     }
//----
//---- Output in Char
   for(cnt=0; cnt<=5; cnt++)
     {
      ObjectCreate("WSO15-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WSO15-"+cnt,OBJPROP_COLOR,FireBrick);
      ObjectSet("WSO15-"+cnt,OBJPROP_WIDTH,2);
      if(cnt<5)
        {
         ObjectCreate("Trend DN15-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet("Trend DN15-"+cnt,OBJPROP_COLOR,Orange);
         ObjectSet("Trend DN15-"+cnt,OBJPROP_WIDTH,2);
        }
      //----
      ObjectCreate("WRO15-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WRO15-"+cnt,OBJPROP_COLOR,Blue);
         ObjectSet("WRO15-"+cnt,OBJPROP_WIDTH,2);
      if(cnt<5)
        {
         ObjectCreate("Trend UP15-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet("Trend Up15-"+cnt,OBJPROP_COLOR,Teal);
         ObjectSet("Trend Up15-"+cnt,OBJPROP_WIDTH,2);
        }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   for(cnt=0; cnt<=5; cnt++)
     {
      ObjectDelete("Trend UP10-"+cnt);
      ObjectDelete("Trend DN10-"+cnt);
      ObjectDelete("Trend UP15-"+cnt);
      ObjectDelete("Trend DN15-"+cnt);
      ObjectDelete("Trend UP5-"+cnt);
      ObjectDelete("Trend DN5-"+cnt);
      ObjectDelete("WSO-"+cnt);
      ObjectDelete("WRO-"+cnt);
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- TODO: add your code here
   double r1,r2,r3,r4,r5,r6;
   int rt1,rt2,rt3,rt4,rt5,rt6;
   double s1,s2,s3,s4,s5,s6;
   int st1,st2,st3,st4,st5,st6;
   
   double r1_10,r2_10,r3_10,r4_10,r5_10,r6_10;
   int rt1_10,rt2_10,rt3_10,rt4_10,rt5_10,rt6_10;
   double s1_10,s2_10,s3_10,s4_10,s5_10,s6_10;
   int st1_10,st2_10,st3_10,st4_10,st5_10,st6_10;

   double r1_15,r2_15,r3_15,r4_15,r5_15,r6_15;
   int rt1_15,rt2_15,rt3_15,rt4_15,rt5_15,rt6_15;
   double s1_15,s2_15,s3_15,s4_15,s5_15,s6_15;
   int st1_15,st2_15,st3_15,st4_15,st5_15,st6_15;
//----    
   if(Bars<Limit) Limit=Bars-nPeriod;
   for(nCurBar=Limit; nCurBar>0; nCurBar--)
     {
      if(Low[nCurBar+(nPeriod-1)/2]==Low[Lowest(NULL,0,MODE_LOW,nPeriod,nCurBar)])
        {
         s6=s5; s5=s4; s4=s3; s3=s2; s2=s1; s1=Low[nCurBar+(nPeriod-1)/2]; 
         st6=st5; st5=st4; st4=st3; st3=st2; st2=st1; st1=nCurBar+(nPeriod-1)/2; 
        }
      if(High[nCurBar+(nPeriod-1)/2]==High[Highest(NULL,0,MODE_HIGH,nPeriod,nCurBar)])
        {
         r6=r5; r5=r4; r4=r3; r3=r2; r2=r1; r1=High[nCurBar+(nPeriod-1)/2]; 
         rt6=rt5; rt5=rt4; rt4=rt3; rt3=rt2; rt2=rt1; rt1=nCurBar+(nPeriod-1)/2;    
        }
     }
     

   if(Bars<Limit10) Limit10=Bars-nPeriod10;
   for(nCurBar10=Limit10; nCurBar10>0; nCurBar10--)
     {
      if(Low[nCurBar10+(nPeriod10-1)/2]==Low[Lowest(NULL,0,MODE_LOW,nPeriod10,nCurBar10)])
        {
         s6_10=s5_10; s5_10=s4_10; s4_10=s3_10; s3_10=s2_10; s2_10=s1_10; s1_10=Low[nCurBar10+(nPeriod10-1)/2];
         st6_10=st5_10; st5_10=st4_10; st4_10=st3_10; st3_10=st2_10; st2_10=st1_10; st1_10=nCurBar10+(nPeriod10-1)/2;
        }
      if(High[nCurBar10+(nPeriod10-1)/2]==High[Highest(NULL,0,MODE_HIGH,nPeriod10,nCurBar10)])
        {
         r6_10=r5_10; r5_10=r4_10; r4_10=r3_10; r3_10=r2_10; r2_10=r1_10; r1_10=High[nCurBar10+(nPeriod10-1)/2];
         rt6_10=rt5_10; rt5_10=rt4_10; rt4_10=rt3_10; rt3_10=rt2_10; rt2_10=rt1_10; rt1_10=nCurBar10+(nPeriod10-1)/2;
        }
     }


   if(Bars<Limit15) Limit15=Bars-nPeriod15;
   for(nCurBar15=Limit15; nCurBar15>0; nCurBar15--)
     {
      if(Low[nCurBar15+(nPeriod15-1)/2]==Low[Lowest(NULL,0,MODE_LOW,nPeriod15,nCurBar15)])
        {
         s6_15=s5_15; s5_15=s4_15; s4_15=s3_15; s3_15=s2_15; s2_15=s1_15; s1_15=Low[nCurBar15+(nPeriod15-1)/2];
         st6_15=st5_15; st5_15=st4_15; st4_15=st3_15; st3_15=st2_15; st2_15=st1_15; st1_15=nCurBar15+(nPeriod15-1)/2;
        }
      if(High[nCurBar15+(nPeriod15-1)/2]==High[Highest(NULL,0,MODE_HIGH,nPeriod15,nCurBar15)])
        {
         r6_15=r5_15; r5_15=r4_15; r4_15=r3_15; r3_15=r2_15; r2_15=r1_15; r1_15=High[nCurBar15+(nPeriod15-1)/2];
         rt6_15=rt5_15; rt5_15=rt4_15; rt4_15=rt3_15; rt3_15=rt2_15; rt2_15=rt1_15; rt1_15=nCurBar15+(nPeriod15-1)/2;
        }
     }
//---- Move Object in Chart

   ObjectMove("Trend DN5-0",1,Time[st1],s1);
   ObjectMove("Trend DN5-0",0,Time[st2],s2);
   ObjectMove("Trend UP5-0",1,Time[rt1],r1);
   ObjectMove("Trend UP5-0",0,Time[rt2],r2);

   ObjectMove("Trend DN10-0",1,Time[st1_10],s1_10);
   ObjectMove("Trend DN10-0",0,Time[st2_10],s2_10);
   ObjectMove("Trend UP10-0",1,Time[rt1_10],r1_10);
   ObjectMove("Trend UP10-0",0,Time[rt2_10],r2_10);

   ObjectMove("Trend DN15-0",1,Time[st1_15],s1_15);
   ObjectMove("Trend DN15-0",0,Time[st2_15],s2_15);
   ObjectMove("Trend UP15-0",1,Time[rt1_15],r1_15);
   ObjectMove("Trend UP15-0",0,Time[rt2_15],r2_15);

   return(0);
  }
//+------------------------------------------------------------------+

